/* 
 * auxapp.h
 *
 * 
 *
 */
 /*
 *
 * Copyright (C) 2005       Yoav Zach <yoav.zach@intel.com>
 *
 */
 /*
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of GNU Lesser General Public
 * License as published by the Free Software Foundation
 * version 2.1 of the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have recieved a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * or view it at http://www.gnu.org/licenses/lgpl.html
 *
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*/
#ifndef _AUXAPP_H
#define _AUXAPP_H

#include <stdint.h>

/* from NPTL: bits/pthreadtypes.h */
#define __SIZEOF_IA32_PTHREAD_ATTR_T 36
typedef union
{
	char __size[__SIZEOF_IA32_PTHREAD_ATTR_T];
	long int __align;
} pthread_attr32_t;

/* from nptl/pthread.h */
/* Detach state.  */
enum
{
	PTHREAD_CREATE_JOINABLE_32,
#define PTHREAD_CREATE_JOINABLE_32 PTHREAD_CREATE_JOINABLE_32
	PTHREAD_CREATE_DETACHED_32
#define PTHREAD_CREATE_DETACHED_32 PTHREAD_CREATE_DETACHED_32
};

struct ia32_runtime_fptr_table {
	uint32_t dlopen;
	uint32_t dlsym;
	uint32_t dlerror;
	uint32_t dlclose;
	uint32_t pthread_create;
	uint32_t pthread_attr_setstack;
	uint32_t pthread_attr_setstacksize;
	uint32_t pthread_attr_setdetachstate;
	uint32_t pthread_attr_init;
	uint32_t pthread_exit;
	uint32_t malloc;
	uint32_t realloc;
	uint32_t free;
	uint32_t dl_iterate_phdr;
	uint32_t jnienv32_fns;
	uint32_t javavm32_fns;
	uint32_t dummy_thread_func;
	uint32_t phdr_iter_callback;
	uint32_t binary_desc_init;
	uint32_t binary_desc_finish;
	uint32_t get_symbol_info_str;
};

#define MME_UPCALL_ARGS_OFFSET 8
#define MME_UPCALL_IDX_OFFSET -4

#endif // _AUXAPP_H
