/* 
 * make_jni_wrappers.c
 *
 * 
 *
 */
 /*
 *
 * Copyright (C) 2005       Yoav Zach <yoav.zach@intel.com>
 *
 */
 /*
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of GNU Lesser General Public
 * License as published by the Free Software Foundation
 * version 2.1 of the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have recieved a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * or view it at http://www.gnu.org/licenses/lgpl.html
 *
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*/
#include <stdio.h>
#include <assert.h>
#include <stdint.h>
#include <string.h>
#include <jni.h>
#include <ia32el_mme_api.h>
#include <jnienv32.h>
#include <auxapp.h>


int main ()
{
#define DEFINE_INDEXED_UPCALL(_idx,_type,_name,_code)\
{\
	printf (".text\n");\
	printf (".align 32\n");\
	printf (".global %s\n", #_name);\
	printf (".type %s,@function\n", #_name);\
	printf ("%s:\n", #_name);\
	printf ("\tpushl %%ebp\n");\
	printf ("\tmovl %%esp, %%ebp\n");\
	printf ("\tmovl $%d, %d(%%esp)\n", _idx,MME_UPCALL_IDX_OFFSET);\
	printf ("\t.byte 0x0f\n");\
	printf ("\t.byte 0xb8\n");\
	printf ("\t.byte 0x%x\n", _code);\
	printf ("\t.byte 0x00\n");\
	printf ("\t.byte 0x00\n");\
	printf ("\t.byte 0x00\n");\
	if (strcmp(#_type, "void") != 0) {\
		if (strcmp (#_type, "jfloat") == 0) {\
			printf ("\tflds -4(%%esp)\n");\
		} else if (strcmp (#_type, "jdouble") == 0) {\
			printf ("\tfldl -8(%%esp)\n");\
		} else if (sizeof (_type) > 4) {\
			assert (sizeof (_type) == 8);\
			printf ("\tmovl -8(%%esp), %%eax\n");\
			printf ("\tmovl -4(%%esp), %%edx\n");\
		} else {\
			printf ("\tmovl -4(%%esp), %%eax\n");\
		}\
	}\
	printf ("\tleave\n");\
	printf ("\tret\n\n");\
}\
	
#define DEFINE_INDEXED_UPCALL_1(_idx,_type,_name,_code) \
    DEFINE_INDEXED_UPCALL(_idx, _type, _name, _code)

/*
 * Define JNIEnv interface methods.
 */
#define JNIENVFN(_idx, _type, _name, _args) \
    DEFINE_INDEXED_UPCALL_1(_idx, _type, JNIENV_IA32_STUB(_name), IA32EL_TRAP_JNI_CALL)

#include "jnifns.h"

/*
 * Define JavaVM interface methods.
 */
#define JAVAVMFN(_idx, _type, _name, _args) \
    DEFINE_INDEXED_UPCALL_1(_idx, _type, JAVAVM_IA32_STUB(_name),IA32EL_TRAP_JAVAVM_CALL)

#include "jvmfns.h"

/*
 * Define JavaVM interface methods.
 */
#define JNIVMFN(_idx, _type, _name, _args) \
    DEFINE_INDEXED_UPCALL_1(_idx, _type, JNIVM_IA32_STUB(_name),IA32EL_TRAP_JNIVM_CALL)

#include "jnivmfns.h"

	return 0;
}
#undef _prefix
