/* 
 * jni32.c
 *
 * 
 *
 */
 /*
 *
 * Copyright (C) 2005       Yoav Zach <yoav.zach@intel.com>
 *
 */
 /*
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of GNU Lesser General Public
 * License as published by the Free Software Foundation
 * version 2.1 of the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have recieved a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * or view it at http://www.gnu.org/licenses/lgpl.html
 *
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*/
#include <jni32.h>
#include <mme_jvm_api.h>
#include <jni32_refmap.h>
#include <jni32_ptrmap.h>
#include <jni32_idmap.h>

/* jvm api function table - jvm passes this table to mme at initialization time */
struct _mme_java_callback_tag HIDDEN g_java_callbacks;

/*****************************************************************************/
/*****************************************************************************/
int32_t HIDDEN
jni32_term ()
{

	int32_t retval = 0;

	retval |= uninit_id_maps ();
	retval |= uninit_ptrmap ();
	retval |= jni32_uninit_refmaps ();

	return retval;
}

/*****************************************************************************/
/*****************************************************************************/
int32_t HIDDEN
jni32_init (struct _mme_java_callback_tag * callbacks)
{
	int32_t retval;

	/* init the refmaps module */
	retval = jni32_init_refmaps ();
	if (retval < 0) {
		DBPRINT (true, "init_refmaps failed\n");
		goto out;
	}

	retval = init_ptrmap ();
	if (retval < 0) {
		DBPRINT (true, "init_ptrmap failed\n");
		goto out;
	}

	retval = init_id_maps ();
	if (retval < 0) {
		DBPRINT (true, "init_id_maps failed\n");
		goto out;
	}

	/* store the pointer to the ia32 javavm struct */
	g_javavm32_fns = g_ia32_runtime.javavm32_fns;

	/* init the jvm callbacks table */
	g_java_callbacks = *callbacks;

	retval = 0;

out:
	return retval;
}
