/* 
 * jni32_args.h
 *
 * 
 *
 */
 /*
 *
 * Copyright (C) 2005       Stanislav Polevic <stanislav.v.polevic@intel.com>
 * Copyright (C) 2005       Vasily Levchenko <vasily.v.levchenko@intel.com>
 * Copyright (C) 2005       Alexander Alexeev <alexander.n.alexeev@intel.com>
 * Copyright (C) 2005       Valery Ushakov <valery.e.ushakov@intel.com>
 * Copyright (C) 2005       Yoav Zach <yoav.zach@intel.com>
 *
 */
 /*
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of GNU Lesser General Public
 * License as published by the Free Software Foundation
 * version 2.1 of the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have recieved a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * or view it at http://www.gnu.org/licenses/lgpl.html
 *
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*/
#ifndef _JNI32_ARGS_H_
#define _JNI32_ARGS_H_

#include <jni.h>

#include <jni32_mth_parse.h>

/*
 * Returns array of arguments retrieved from stack.
 */
extern jvalue *retrieve_args_stack(ia32el_context32 * ec32, const struct jni32_method_info *method, uint32_t sp32, jvalue *args);

/*
 * Returns array of arguments retreived from jvalue array.
 */
extern jvalue *retrieve_args_array(ia32el_context32 * ec32, const struct jni32_method_info *method, uint32_t sp32, jvalue *args);

/*
 * Returns array of arguments retreived from va_list.
 */
extern jvalue *retrieve_args_valist(ia32el_context32 * ec32, const struct jni32_method_info *method, uint32_t sp32, jvalue *args);

#endif /*_JNI32_ARGS_H_*/
