/* 
 * jni32_diag.h
 *
 * 
 *
 */
 /*
 *
 * Copyright (C) 2005       Stanislav Polevic <stanislav.v.polevic@intel.com>
 * Copyright (C) 2005       Vasily Levchenko <vasily.v.levchenko@intel.com>
 * Copyright (C) 2005       Alexander Alexeev <alexander.n.alexeev@intel.com>
 * Copyright (C) 2005       Valery Ushakov <valery.e.ushakov@intel.com>
 * Copyright (C) 2005       Yoav Zach <yoav.zach@intel.com>
 *
 */
 /*
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of GNU Lesser General Public
 * License as published by the Free Software Foundation
 * version 2.1 of the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have recieved a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * or view it at http://www.gnu.org/licenses/lgpl.html
 *
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*/
#ifndef _JNI32_DIAG_H_
#define _JNI32_DIAG_H_

#include <jni.h>

#include <mme_internal.h>

#define JNI32_THROW_INIT_EXCEPTION(vm) do {			\
	jni32_throw_init_error(vm, JNI32_INTERNAL, __FUNCTION__);	\
} while (/*CONSTCOND*/0)

#define __JNI32_THROW_EXCEPTION(exception_num) do {	\
	jni32_throw_error(exception_num, __FUNCTION__);	\
} while (/*CONSTCOND*/0)

#define JNI32_THROW_UNKNOW_EXCEPTION			\
	__JNI32_THROW_EXCEPTION(JNI32_UNKNOW)

#define JNI32_THROW_INTERNAL_EXCEPTION			\
	__JNI32_THROW_EXCEPTION(JNI32_INTERNAL)

#define JNI32_THROW_UNSATISFIED_LINK_EXCEPTION		\
	__JNI32_THROW_EXCEPTION(JNI32_UNSATISFIED_LINK)

#define JNI32_THROW_STACK_OVERFLOW_EXCEPTION		\
	__JNI32_THROW_EXCEPTION(JNI32_STACK_OVERFLOW)

#define JNI32_THROW_OUT_OF_MEMORY_EXCEPTION		\
	__JNI32_THROW_EXCEPTION(JNI32_OUT_OF_MEMORY)

enum exceptions {
	JNI32_UNKNOW,			/* java.lang.UnknownError */
	JNI32_INTERNAL,			/* java.lang.InternalError */
	JNI32_UNSATISFIED_LINK,		/* java.lang.UnsatisfiedLinkError */
	JNI32_STACK_OVERFLOW,		/* java.lang.StackOverflowError	*/
	JNI32_LINKAGE,			/* java.lang.LinkageError */
	JNI32_OUT_OF_MEMORY,		/* java.lang.OutOfMemoryError */

	JNI32_NEXCEPTIONS
};

extern void jni32_throw_error(enum exceptions exception_num, const char *message);
extern void jni32_throw_init_error(JavaVM *vm, enum exceptions exception_num, const char *message);

#endif /*_JNI32_DIAG_H_*/
