/* 
 * jni32_hash_table.h
 *
 * 
 *
 */
 /*
 *
 * Copyright (C) 2005       Stanislav Polevic <stanislav.v.polevic@intel.com>
 * Copyright (C) 2005       Vasily Levchenko <vasily.v.levchenko@intel.com>
 * Copyright (C) 2005       Alexander Alexeev <alexander.n.alexeev@intel.com>
 * Copyright (C) 2005       Valery Ushakov <valery.e.ushakov@intel.com>
 * Copyright (C) 2005       Yoav Zach <yoav.zach@intel.com>
 *
 */
 /*
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of GNU Lesser General Public
 * License as published by the Free Software Foundation
 * version 2.1 of the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have recieved a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * or view it at http://www.gnu.org/licenses/lgpl.html
 *
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*/
#ifndef _JNI32_HASH_TABLE_H_
#define _JNI32_HASH_TABLE_H_

#include <mme_internal.h>

typedef	enum jni32_hash_table_res_tag{
	JNI32_HASH_TABLE_ERROR = -1,
	JNI32_HASH_TABLE_KEY_NEW = 0,
	JNI32_HASH_TABLE_KEY_LACK = 1,
	JNI32_HASH_TABLE_KEY_EXIST = 2
} jni32_hash_table_res;

typedef void *jni32_hash_table;
typedef uint64_t key_type;
typedef uint64_t val_type;

typedef size_t (*hash_func)(const key_type value);

extern jni32_hash_table HIDDEN jni32_hash_table_create(size_t table_size, hash_func fptr);

extern void HIDDEN jni32_hash_table_destroy(const jni32_hash_table table);

extern jni32_hash_table_res HIDDEN jni32_set_hash_table_value(const jni32_hash_table table, const key_type key, const val_type value);

extern jni32_hash_table_res HIDDEN jni32_get_hash_table_value(const jni32_hash_table table, const key_type key, val_type *value);

extern jni32_hash_table_res HIDDEN jni32_del_hash_table_pair(const jni32_hash_table table, const key_type key);


#endif /*_JNI32_HASH_TABLE_H_*/
