/* 
 * jni32_idmap.h
 *
 * 
 *
 */
 /*
 *
 * Copyright (C) 2005       Stanislav Polevic <stanislav.v.polevic@intel.com>
 * Copyright (C) 2005       Vasily Levchenko <vasily.v.levchenko@intel.com>
 * Copyright (C) 2005       Alexander Alexeev <alexander.n.alexeev@intel.com>
 * Copyright (C) 2005       Valery Ushakov <valery.e.ushakov@intel.com>
 * Copyright (C) 2005       Yoav Zach <yoav.zach@intel.com>
 *
 */
 /*
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of GNU Lesser General Public
 * License as published by the Free Software Foundation
 * version 2.1 of the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have recieved a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * or view it at http://www.gnu.org/licenses/lgpl.html
 *
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*/
#ifndef _JNI32_IDMAP_H_
#define _JNI32_IDMAP_H_

#include <jni.h>
#include <stdint.h>

#include <mme_internal.h>
#include <jni32_mth_parse.h>

/* fids/mids in the IA32 world */
typedef uint32_t fieldID32;
typedef uint32_t methodID32;

extern int HIDDEN init_id_maps(void);
extern int HIDDEN uninit_id_maps(void);


/*
 * fieldID
 */

extern uint32_t HIDDEN marshal_fieldID(jfieldID fid);
extern jfieldID HIDDEN demarshal_fieldID(uint32_t *psp32);


/*
 * methodID
 */

struct jni32_jmethodID_tag {
	struct jni32_method_info method_info;
	methodID32 mid32;
	jmethodID mid64;
};

typedef struct jni32_jmethodID_tag *jni32_jmethodID;

extern uint32_t HIDDEN marshal_methodID(jni32_jmethodID jni32_mid);
extern jni32_jmethodID HIDDEN demarshal_methodID(uint32_t *psp32);
extern jni32_jmethodID HIDDEN create_method_entry(jmethodID mid, const char *name, const char *sig);
extern void HIDDEN free_method_entry(jni32_jmethodID method);

#endif /*_JNI32_IDMAP_H_*/
