/* 
 * jni32_map.h
 *
 * 
 *
 */
 /*
 *
 * Copyright (C) 2005       Stanislav Polevic <stanislav.v.polevic@intel.com>
 * Copyright (C) 2005       Vasily Levchenko <vasily.v.levchenko@intel.com>
 * Copyright (C) 2005       Alexander Alexeev <alexander.n.alexeev@intel.com>
 * Copyright (C) 2005       Valery Ushakov <valery.e.ushakov@intel.com>
 * Copyright (C) 2005       Yoav Zach <yoav.zach@intel.com>
 *
 */
 /*
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of GNU Lesser General Public
 * License as published by the Free Software Foundation
 * version 2.1 of the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have recieved a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * or view it at http://www.gnu.org/licenses/lgpl.html
 *
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*/
#ifndef _JNI32_MAP_H_
#define _JNI32_MAP_H_

#include <stdio.h>
#include <stdint.h>

struct jni32_map_element {
	void *value;
	int32_t	next_free;
};

struct jni32_map {
	struct jni32_map_element *data;
	int32_t size;
	int32_t free;
	int32_t increment_size;
};

/*
 * Create map.
 */
extern int32_t jni32_map_create(struct jni32_map *map, int32_t init_size, int32_t inc_size);
extern void jni32_map_destroy(struct jni32_map *map);
extern int32_t jni32_map_grow(struct jni32_map *map, size_t more);
extern void jni32_map_freelist_add(struct jni32_map *map, int32_t free_tail);
extern int32_t jni32_map_add(struct jni32_map *map, void *value64, int32_t *result_value32);
extern void * jni32_map_del(struct jni32_map *map, int32_t value32);
extern void * jni32_map_get(struct jni32_map *map, int32_t value32);


#endif /*_JNI32_MAP_H_*/
