/* 
 * jni32_ptrmap.h
 *
 * 
 *
 */
 /*
 *
 * Copyright (C) 2005       Stanislav Polevic <stanislav.v.polevic@intel.com>
 * Copyright (C) 2005       Vasily Levchenko <vasily.v.levchenko@intel.com>
 * Copyright (C) 2005       Alexander Alexeev <alexander.n.alexeev@intel.com>
 * Copyright (C) 2005       Valery Ushakov <valery.e.ushakov@intel.com>
 * Copyright (C) 2005       Yoav Zach <yoav.zach@intel.com>
 *
 */
 /*
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of GNU Lesser General Public
 * License as published by the Free Software Foundation
 * version 2.1 of the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have recieved a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * or view it at http://www.gnu.org/licenses/lgpl.html
 *
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*/
#ifndef _JNI32_PTRMAP_H_
#define _JNI32_PTRMAP_H_

#include <stdint.h>


#include <mme_internal.h>
#include <jni32_stack.h>
#include <btmix.h>

int32_t HIDDEN init_ptrmap(void);
int32_t HIDDEN uninit_ptrmap(void);
HIDDEN void * jni32_add_ptrmap(void *ptr64, size_t size);
HIDDEN void * jni32_get_ptrmap(void *ptr32);
int32_t HIDDEN jni32_del_ptrmap(void *ptr32, int32_t free_ptr32);

static inline void *
demarshal_ptr(ptr32_t * psp32)
{
	void *ptr64;
	uint32_t ptr32 = btmix_pop_jobject (psp32);

	ptr64 = I2P(ptr32);

	return ptr64;
}

#endif /*_JNI32_PTRMAP_H_*/
