/* 
 * jni32_ref_tags.h
 *
 * 
 *
 */
 /*
 *
 * Copyright (C) 2005       Stanislav Polevic <stanislav.v.polevic@intel.com>
 * Copyright (C) 2005       Vasily Levchenko <vasily.v.levchenko@intel.com>
 * Copyright (C) 2005       Alexander Alexeev <alexander.n.alexeev@intel.com>
 * Copyright (C) 2005       Valery Ushakov <valery.e.ushakov@intel.com>
 * Copyright (C) 2005       Yoav Zach <yoav.zach@intel.com>
 *
 */
 /*
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of GNU Lesser General Public
 * License as published by the Free Software Foundation
 * version 2.1 of the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have recieved a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * or view it at http://www.gnu.org/licenses/lgpl.html
 *
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*/
#ifndef _JNI32_REF_TAGS_H_
#define _JNI32_REF_TAGS_H_


#define TAG_SPACE_BIT (0x3)
#define TAG_SPACE_FILLED (0x7)
	
#define NULL_REF_TAG   (0x00)
#define LOCAL_REF_TAG  (0x01)
#define GLOBAL_REF_TAG (0x02)
#define WEAK_REF_TAG   (0x03)
#define FIELD_ID_TAG   (0x04)
#define METHOD_ID_TAG  (0x05)


#define GET_CERTAIN_TAG(src) ((src) & TAG_SPACE_FILLED)
#define RM_CERTAIN_TAG(ID)  ((uint32_t)(ID) >> TAG_SPACE_BIT)

#define SET_CERTAIN_TAG(dst, value) (((dst) << TAG_SPACE_BIT) | (value))
#define IS_CERTAIN_TAG(src, value)  (GET_CERTAIN_TAG(src) == (value))


#define SET_LOCAL_REF_TAG(val)  SET_CERTAIN_TAG(val, LOCAL_REF_TAG) 
#define IS_LOCAL_REF(val)  IS_CERTAIN_TAG(val, LOCAL_REF_TAG)

#define SET_GLOBAL_REF_TAG(val)  SET_CERTAIN_TAG(val, GLOBAL_REF_TAG) 
#define IS_GLOBAL_REF(val)  IS_CERTAIN_TAG(val, GLOBAL_REF_TAG)

#define SET_WEAK_REF_TAG(val)  SET_CERTAIN_TAG(val, WEAK_REF_TAG) 
#define IS_WEAK_REF(val)  IS_CERTAIN_TAG(val, WEAK_REF_TAG)

#define SET_FILED_ID_TAG(val)  SET_CERTAIN_TAG(val, FIELD_ID_TAG) 
#define IS_FILED_ID(val)  IS_CERTAIN_TAG(val, FIELD_ID_TAG)

#define SET_METHOD_ID_TAG(val)  SET_CERTAIN_TAG(val, METHOD_ID_TAG) 
#define IS_METHOD_ID(val)  IS_CERTAIN_TAG(val, METHOD_ID_TAG)



#endif /*_JNI32_REF_TAGS_H_*/
