/* 
 * jni32_refmap.h
 *
 * 
 *
 */
 /*
 *
 * Copyright (C) 2005       Stanislav Polevic <stanislav.v.polevic@intel.com>
 * Copyright (C) 2005       Vasily Levchenko <vasily.v.levchenko@intel.com>
 * Copyright (C) 2005       Alexander Alexeev <alexander.n.alexeev@intel.com>
 * Copyright (C) 2005       Valery Ushakov <valery.e.ushakov@intel.com>
 * Copyright (C) 2005       Yoav Zach <yoav.zach@intel.com>
 *
 */
 /*
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of GNU Lesser General Public
 * License as published by the Free Software Foundation
 * version 2.1 of the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have recieved a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * or view it at http://www.gnu.org/licenses/lgpl.html
 *
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*/
#ifndef _MME_REFMAP_H
#define _MME_REFMAP_H

#include <mme_internal.h>
#include <stdint.h>

extern HIDDEN void * jni32_get_ref(uint32_t ref32);
extern HIDDEN void * jni32_demarshal_ref(ptr32_t * psp32);
extern HIDDEN void * jni32_delete_ref(uint32_t ref32);

extern int32_t HIDDEN jni32_init_refmaps(void);
extern int32_t HIDDEN jni32_uninit_refmaps(void);

extern int32_t HIDDEN jni32_init_local_refmap(void);
extern bool    HIDDEN jni32_is_local_refmap_inited(void);
extern int32_t HIDDEN jni32_uninit_local_refmap(void);
extern int32_t HIDDEN jni32_push_local_ref_frame(int32_t push_size);
extern int32_t HIDDEN jni32_predef_size_push_local_ref_frame(void);
extern int32_t HIDDEN jni32_pop_local_ref_frame(void);
extern uint32_t HIDDEN jni32_marshal_local_ref(void *ref64);
extern HIDDEN void * jni32_local_ref_del(uint32_t ref32);

extern uint32_t HIDDEN jni32_marshal_global_ref(void *ref64);
extern HIDDEN void * jni32_global_ref_del(uint32_t ref32);

extern uint32_t HIDDEN jni32_marshal_weak_ref(void *ref64);
extern HIDDEN void * jni32_weak_ref_del(uint32_t ref32);

#endif // _MME_REFMAP_H
