/* 
 * jni32_stack.h
 *
 * 
 *
 */
 /*
 *
 * Copyright (C) 2005       Stanislav Polevic <stanislav.v.polevic@intel.com>
 * Copyright (C) 2005       Vasily Levchenko <vasily.v.levchenko@intel.com>
 * Copyright (C) 2005       Alexander Alexeev <alexander.n.alexeev@intel.com>
 * Copyright (C) 2005       Valery Ushakov <valery.e.ushakov@intel.com>
 * Copyright (C) 2005       Yoav Zach <yoav.zach@intel.com>
 *
 */
 /*
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of GNU Lesser General Public
 * License as published by the Free Software Foundation
 * version 2.1 of the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have recieved a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * or view it at http://www.gnu.org/licenses/lgpl.html
 *
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*/
#ifndef _JNI32_STACK_H_
#define _JNI32_STACK_H_

#include <btmix.h>

/* Functions for poping argument from the stack */
#define btmix_pop_jboolean  btmix_pop_uchar
#define btmix_pop_jbyte     btmix_pop_char
#define btmix_pop_jchar     btmix_pop_ushort
#define btmix_pop_jshort    btmix_pop_short 
#define btmix_pop_jint      btmix_pop_int
#define btmix_pop_jlong     btmix_pop_llong
#define btmix_pop_jfloat    btmix_pop_float
#define btmix_pop_jdouble   btmix_pop_double
#define btmix_pop_jobject   btmix_pop_uint
#define btmix_pop_pointer   btmix_pop_uint

    
/* Functions for changing return value when returning from trampoline */
#define btmix_set_retval_jboolean  btmix_set_retval_uchar
#define btmix_set_retval_jbyte     btmix_set_retval_char
#define btmix_set_retval_jchar     btmix_set_retval_ushort
#define btmix_set_retval_jshort    btmix_set_retval_short 
#define btmix_set_retval_jint      btmix_set_retval_int
#define btmix_set_retval_jlong     btmix_set_retval_llong
#define btmix_set_retval_jfloat    btmix_set_retval_float
#define btmix_set_retval_jdouble   btmix_set_retval_double
#define btmix_set_retval_jobject   btmix_set_retval_uint
#define btmix_set_retval_pointer   btmix_set_retval_uint


#endif /*_JNI32_STACK_H_*/
