/* 
 * jni32_trampolines.h
 *
 * 
 *
 */
 /*
 *
 * Copyright (C) 2005       Stanislav Polevic <stanislav.v.polevic@intel.com>
 * Copyright (C) 2005       Vasily Levchenko <vasily.v.levchenko@intel.com>
 * Copyright (C) 2005       Alexander Alexeev <alexander.n.alexeev@intel.com>
 * Copyright (C) 2005       Valery Ushakov <valery.e.ushakov@intel.com>
 * Copyright (C) 2005       Yoav Zach <yoav.zach@intel.com>
 *
 */
 /*
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of GNU Lesser General Public
 * License as published by the Free Software Foundation
 * version 2.1 of the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have recieved a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * or view it at http://www.gnu.org/licenses/lgpl.html
 *
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*/
#include <stdint.h>
#include <jni.h>

#include <ia32el_mme_api.h>

#define DEFINE_JNIENV_IA64_TRAMPOLINE(_name)\
int64_t JNIENV_IA64_TRAMPOLINE(_name)(ia32el_context32 *ec32)


#define JNIENV_IA64_TRAMPOLINE(_name) _Jni64_##_name##_trampoline

#define DECLARE_JNIENV_IA64_TRAMPOLINE(_name)\
extern int64_t JNIENV_IA64_TRAMPOLINE(_name)(ia32el_context32 *)\
	__attribute__ ((visibility ("hidden")))

/* declare trampolines */
#define JNIENVFN(_idx, _type, _name, _args)\
	DECLARE_JNIENV_IA64_TRAMPOLINE(_name);

#include <jnifns.h>
