/* 
 * jnifns.h
 *
 * 
 *
 */
 /*
 *
 * Copyright (C) 2005       Stanislav Polevic <stanislav.v.polevic@intel.com>
 * Copyright (C) 2005       Vasily Levchenko <vasily.v.levchenko@intel.com>
 * Copyright (C) 2005       Alexander Alexeev <alexander.n.alexeev@intel.com>
 * Copyright (C) 2005       Valery Ushakov <valery.e.ushakov@intel.com>
 *
 */
 /*
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of GNU Lesser General Public
 * License as published by the Free Software Foundation
 * version 2.1 of the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have recieved a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * or view it at http://www.gnu.org/licenses/lgpl.html
 *
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*/

#ifndef JNIENVFN
#define JNIENVFN(_idx, _type, _name, _args) /* empty */
#endif

#ifndef JNIENVLAST
#define JNIENVLAST(_idx) /* empty */
#endif

#define MAX_JNIENV_IDX 231
/*
 *     index  return type    function name                  arguments
 */
JNIENVFN(  4, jint,          GetVersion,                    (JNIEnv *env))

JNIENVFN(  5, jclass,        DefineClass,                   (JNIEnv *env, const char *name, jobject loader, const jbyte *buf, jsize len))
JNIENVFN(  6, jclass,        FindClass,                     (JNIEnv *env, const char *name))

JNIENVFN(  7, jmethodID,     FromReflectedMethod,           (JNIEnv *env, jobject method))
JNIENVFN(  8, jfieldID,      FromReflectedField,            (JNIEnv *env, jobject field))

JNIENVFN(  9, jobject,       ToReflectedMethod,             (JNIEnv *env, jclass cls, jmethodID methodID, jboolean isStatic))

JNIENVFN( 10, jclass,        GetSuperclass,                 (JNIEnv *env, jclass sub))
JNIENVFN( 11, jboolean,      IsAssignableFrom,              (JNIEnv *env, jclass sub, jclass sup))

JNIENVFN( 12, jobject,       ToReflectedField,              (JNIEnv *env, jclass cls, jfieldID fieldID, jboolean isStatic))

JNIENVFN( 13, jint,          Throw,                         (JNIEnv *env, jthrowable obj))
JNIENVFN( 14, jint,          ThrowNew,                      (JNIEnv *env, jclass clazz, const char *msg))
JNIENVFN( 15, jthrowable,    ExceptionOccurred,             (JNIEnv *env))
JNIENVFN( 16, void,          ExceptionDescribe,             (JNIEnv *env))
JNIENVFN( 17, void,          ExceptionClear,                (JNIEnv *env))
JNIENVFN( 18, void,          FatalError,                    (JNIEnv *env, const char *msg))

JNIENVFN( 19, jint,          PushLocalFrame,                (JNIEnv *env, jint capacity))
JNIENVFN( 20, jobject,       PopLocalFrame,                 (JNIEnv *env, jobject result))

JNIENVFN( 21, jobject,       NewGlobalRef,                  (JNIEnv *env, jobject lobj))
JNIENVFN( 22, void,          DeleteGlobalRef,               (JNIEnv *env, jobject gref))
JNIENVFN( 23, void,          DeleteLocalRef,                (JNIEnv *env, jobject obj))
JNIENVFN( 24, jboolean,      IsSameObject,                  (JNIEnv *env, jobject obj1, jobject obj2))
JNIENVFN( 25, jobject,       NewLocalRef,                   (JNIEnv *env, jobject ref))
JNIENVFN( 26, jint,          EnsureLocalCapacity,           (JNIEnv *env, jint capacity))

JNIENVFN( 27, jobject,       AllocObject,                   (JNIEnv *env, jclass clazz))
JNIENVFN( 28, jobject,       NewObject,                     (JNIEnv *env, jclass clazz, jmethodID methodID, ...))
JNIENVFN( 29, jobject,       NewObjectV,                    (JNIEnv *env, jclass clazz, jmethodID methodID, va_list args))
JNIENVFN( 30, jobject,       NewObjectA,                    (JNIEnv *env, jclass clazz, jmethodID methodID, const jvalue *args))

JNIENVFN( 31, jclass,        GetObjectClass,                (JNIEnv *env, jobject obj))
JNIENVFN( 32, jboolean,      IsInstanceOf,                  (JNIEnv *env, jobject obj, jclass clazz))

JNIENVFN( 33, jmethodID,     GetMethodID,                   (JNIEnv *env, jclass clazz, const char *name, const char *sig))

JNIENVFN( 34, jobject,       CallObjectMethod,              (JNIEnv *env, jobject obj, jmethodID methodID, ...))
JNIENVFN( 35, jobject,       CallObjectMethodV,             (JNIEnv *env, jobject obj, jmethodID methodID, va_list args))
JNIENVFN( 36, jobject,       CallObjectMethodA,             (JNIEnv *env, jobject obj, jmethodID methodID, const jvalue *args))

JNIENVFN( 37, jboolean,      CallBooleanMethod,             (JNIEnv *env, jobject obj, jmethodID methodID, ...))
JNIENVFN( 38, jboolean,      CallBooleanMethodV,            (JNIEnv *env, jobject obj, jmethodID methodID, va_list args))
JNIENVFN( 39, jboolean,      CallBooleanMethodA,            (JNIEnv *env, jobject obj, jmethodID methodID, const jvalue *args))

JNIENVFN( 40, jbyte,         CallByteMethod,                (JNIEnv *env, jobject obj, jmethodID methodID, ...))
JNIENVFN( 41, jbyte,         CallByteMethodV,               (JNIEnv *env, jobject obj, jmethodID methodID, va_list args))
JNIENVFN( 42, jbyte,         CallByteMethodA,               (JNIEnv *env, jobject obj, jmethodID methodID, const jvalue *args))

JNIENVFN( 43, jchar,         CallCharMethod,                (JNIEnv *env, jobject obj, jmethodID methodID, ...))
JNIENVFN( 44, jchar,         CallCharMethodV,               (JNIEnv *env, jobject obj, jmethodID methodID, va_list args))
JNIENVFN( 45, jchar,         CallCharMethodA,               (JNIEnv *env, jobject obj, jmethodID methodID, const jvalue *args))

JNIENVFN( 46, jshort,        CallShortMethod,               (JNIEnv *env, jobject obj, jmethodID methodID, ...))
JNIENVFN( 47, jshort,        CallShortMethodV,              (JNIEnv *env, jobject obj, jmethodID methodID, va_list args))
JNIENVFN( 48, jshort,        CallShortMethodA,              (JNIEnv *env, jobject obj, jmethodID methodID, const jvalue *args))

JNIENVFN( 49, jint,          CallIntMethod,                 (JNIEnv *env, jobject obj, jmethodID methodID, ...))
JNIENVFN( 50, jint,          CallIntMethodV,                (JNIEnv *env, jobject obj, jmethodID methodID, va_list args))
JNIENVFN( 51, jint,          CallIntMethodA,                (JNIEnv *env, jobject obj, jmethodID methodID, const jvalue *args))

JNIENVFN( 52, jlong,         CallLongMethod,                (JNIEnv *env, jobject obj, jmethodID methodID, ...))
JNIENVFN( 53, jlong,         CallLongMethodV,               (JNIEnv *env, jobject obj, jmethodID methodID, va_list args))
JNIENVFN( 54, jlong,         CallLongMethodA,               (JNIEnv *env, jobject obj, jmethodID methodID, const jvalue *args))

JNIENVFN( 55, jfloat,        CallFloatMethod,               (JNIEnv *env, jobject obj, jmethodID methodID, ...))
JNIENVFN( 56, jfloat,        CallFloatMethodV,              (JNIEnv *env, jobject obj, jmethodID methodID, va_list args))
JNIENVFN( 57, jfloat,        CallFloatMethodA,              (JNIEnv *env, jobject obj, jmethodID methodID, const jvalue *args))

JNIENVFN( 58, jdouble,       CallDoubleMethod,              (JNIEnv *env, jobject obj, jmethodID methodID, ...))
JNIENVFN( 59, jdouble,       CallDoubleMethodV,             (JNIEnv *env, jobject obj, jmethodID methodID, va_list args))
JNIENVFN( 60, jdouble,       CallDoubleMethodA,             (JNIEnv *env, jobject obj, jmethodID methodID, const jvalue *args))

JNIENVFN( 61, void,          CallVoidMethod,                (JNIEnv *env, jobject obj, jmethodID methodID, ...))
JNIENVFN( 62, void,          CallVoidMethodV,               (JNIEnv *env, jobject obj, jmethodID methodID, va_list args))
JNIENVFN( 63, void,          CallVoidMethodA,               (JNIEnv *env, jobject obj, jmethodID methodID, const jvalue *args))

JNIENVFN( 64, jobject,       CallNonvirtualObjectMethod,    (JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID, ...))
JNIENVFN( 65, jobject,       CallNonvirtualObjectMethodV,   (JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID, va_list args))
JNIENVFN( 66, jobject,       CallNonvirtualObjectMethodA,   (JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID, const jvalue *args))

JNIENVFN( 67, jboolean,      CallNonvirtualBooleanMethod,   (JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID, ...))
JNIENVFN( 68, jboolean,      CallNonvirtualBooleanMethodV,  (JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID, va_list args))
JNIENVFN( 69, jboolean,      CallNonvirtualBooleanMethodA,  (JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID, const jvalue *args))

JNIENVFN( 70, jbyte,         CallNonvirtualByteMethod,      (JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID, ...))
JNIENVFN( 71, jbyte,         CallNonvirtualByteMethodV,     (JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID, va_list args))
JNIENVFN( 72, jbyte,         CallNonvirtualByteMethodA,     (JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID, const jvalue *args))

JNIENVFN( 73, jchar,         CallNonvirtualCharMethod,      (JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID, ...))
JNIENVFN( 74, jchar,         CallNonvirtualCharMethodV,     (JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID, va_list args))
JNIENVFN( 75, jchar,         CallNonvirtualCharMethodA,     (JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID, const jvalue *args))

JNIENVFN( 76, jshort,        CallNonvirtualShortMethod,     (JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID, ...))
JNIENVFN( 77, jshort,        CallNonvirtualShortMethodV,    (JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID, va_list args))
JNIENVFN( 78, jshort,        CallNonvirtualShortMethodA,    (JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID, const jvalue *args))

JNIENVFN( 79, jint,          CallNonvirtualIntMethod,       (JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID, ...))
JNIENVFN( 80, jint,          CallNonvirtualIntMethodV,      (JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID, va_list args))
JNIENVFN( 81, jint,          CallNonvirtualIntMethodA,      (JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID, const jvalue *args))

JNIENVFN( 82, jlong,         CallNonvirtualLongMethod,      (JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID, ...))
JNIENVFN( 83, jlong,         CallNonvirtualLongMethodV,     (JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID, va_list args))
JNIENVFN( 84, jlong,         CallNonvirtualLongMethodA,     (JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID, const jvalue *args))

JNIENVFN( 85, jfloat,        CallNonvirtualFloatMethod,     (JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID, ...))
JNIENVFN( 86, jfloat,        CallNonvirtualFloatMethodV,    (JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID, va_list args))
JNIENVFN( 87, jfloat,        CallNonvirtualFloatMethodA,    (JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID, const jvalue *args))

JNIENVFN( 88, jdouble,       CallNonvirtualDoubleMethod,    (JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID, ...))
JNIENVFN( 89, jdouble,       CallNonvirtualDoubleMethodV,   (JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID, va_list args))
JNIENVFN( 90, jdouble,       CallNonvirtualDoubleMethodA,   (JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID, const jvalue *args))

JNIENVFN( 91, void,          CallNonvirtualVoidMethod,      (JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID, ...))
JNIENVFN( 92, void,          CallNonvirtualVoidMethodV,     (JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID, va_list args))
JNIENVFN( 93, void,          CallNonvirtualVoidMethodA,     (JNIEnv *env, jobject obj, jclass clazz, jmethodID methodID, const jvalue *args))

JNIENVFN( 94, jfieldID,      GetFieldID,                    (JNIEnv *env, jclass clazz, const char *name, const char *sig))

JNIENVFN( 95, jobject,       GetObjectField,                (JNIEnv *env, jobject obj, jfieldID fieldID))
JNIENVFN( 96, jboolean,      GetBooleanField,               (JNIEnv *env, jobject obj, jfieldID fieldID))
JNIENVFN( 97, jbyte,         GetByteField,                  (JNIEnv *env, jobject obj, jfieldID fieldID))
JNIENVFN( 98, jchar,         GetCharField,                  (JNIEnv *env, jobject obj, jfieldID fieldID))
JNIENVFN( 99, jshort,        GetShortField,                 (JNIEnv *env, jobject obj, jfieldID fieldID))
JNIENVFN(100, jint,          GetIntField,                   (JNIEnv *env, jobject obj, jfieldID fieldID))
JNIENVFN(101, jlong,         GetLongField,                  (JNIEnv *env, jobject obj, jfieldID fieldID))
JNIENVFN(102, jfloat,        GetFloatField,                 (JNIEnv *env, jobject obj, jfieldID fieldID))
JNIENVFN(103, jdouble,       GetDoubleField,                (JNIEnv *env, jobject obj, jfieldID fieldID))

JNIENVFN(104, void,          SetObjectField,                (JNIEnv *env, jobject obj, jfieldID fieldID, jobject val))
JNIENVFN(105, void,          SetBooleanField,               (JNIEnv *env, jobject obj, jfieldID fieldID, jboolean val))
JNIENVFN(106, void,          SetByteField,                  (JNIEnv *env, jobject obj, jfieldID fieldID, jbyte val))
JNIENVFN(107, void,          SetCharField,                  (JNIEnv *env, jobject obj, jfieldID fieldID, jchar val))
JNIENVFN(108, void,          SetShortField,                 (JNIEnv *env, jobject obj, jfieldID fieldID, jshort val))
JNIENVFN(109, void,          SetIntField,                   (JNIEnv *env, jobject obj, jfieldID fieldID, jint val))
JNIENVFN(110, void,          SetLongField,                  (JNIEnv *env, jobject obj, jfieldID fieldID, jlong val))
JNIENVFN(111, void,          SetFloatField,                 (JNIEnv *env, jobject obj, jfieldID fieldID, jfloat val))
JNIENVFN(112, void,          SetDoubleField,                (JNIEnv *env, jobject obj, jfieldID fieldID, jdouble val))

JNIENVFN(113, jmethodID,     GetStaticMethodID,             (JNIEnv *env, jclass clazz, const char *name, const char *sig))

JNIENVFN(114, jobject,       CallStaticObjectMethod,        (JNIEnv *env, jclass clazz, jmethodID methodID, ...))
JNIENVFN(115, jobject,       CallStaticObjectMethodV,       (JNIEnv *env, jclass clazz, jmethodID methodID, va_list args))
JNIENVFN(116, jobject,       CallStaticObjectMethodA,       (JNIEnv *env, jclass clazz, jmethodID methodID, const jvalue *args))

JNIENVFN(117, jboolean,      CallStaticBooleanMethod,       (JNIEnv *env, jclass clazz, jmethodID methodID, ...))
JNIENVFN(118, jboolean,      CallStaticBooleanMethodV,      (JNIEnv *env, jclass clazz, jmethodID methodID, va_list args))
JNIENVFN(119, jboolean,      CallStaticBooleanMethodA,      (JNIEnv *env, jclass clazz, jmethodID methodID, const jvalue *args))

JNIENVFN(120, jbyte,         CallStaticByteMethod,          (JNIEnv *env, jclass clazz, jmethodID methodID, ...))
JNIENVFN(121, jbyte,         CallStaticByteMethodV,         (JNIEnv *env, jclass clazz, jmethodID methodID, va_list args))
JNIENVFN(122, jbyte,         CallStaticByteMethodA,         (JNIEnv *env, jclass clazz, jmethodID methodID, const jvalue *args))

JNIENVFN(123, jchar,         CallStaticCharMethod,          (JNIEnv *env, jclass clazz, jmethodID methodID, ...))
JNIENVFN(124, jchar,         CallStaticCharMethodV,         (JNIEnv *env, jclass clazz, jmethodID methodID, va_list args))
JNIENVFN(125, jchar,         CallStaticCharMethodA,         (JNIEnv *env, jclass clazz, jmethodID methodID, const jvalue *args))

JNIENVFN(126, jshort,        CallStaticShortMethod,         (JNIEnv *env, jclass clazz, jmethodID methodID, ...))
JNIENVFN(127, jshort,        CallStaticShortMethodV,        (JNIEnv *env, jclass clazz, jmethodID methodID, va_list args))
JNIENVFN(128, jshort,        CallStaticShortMethodA,        (JNIEnv *env, jclass clazz, jmethodID methodID, const jvalue *args))

JNIENVFN(129, jint,          CallStaticIntMethod,           (JNIEnv *env, jclass clazz, jmethodID methodID, ...))
JNIENVFN(130, jint,          CallStaticIntMethodV,          (JNIEnv *env, jclass clazz, jmethodID methodID, va_list args))
JNIENVFN(131, jint,          CallStaticIntMethodA,          (JNIEnv *env, jclass clazz, jmethodID methodID, const jvalue *args))

JNIENVFN(132, jlong,         CallStaticLongMethod,          (JNIEnv *env, jclass clazz, jmethodID methodID, ...))
JNIENVFN(133, jlong,         CallStaticLongMethodV,         (JNIEnv *env, jclass clazz, jmethodID methodID, va_list args))
JNIENVFN(134, jlong,         CallStaticLongMethodA,         (JNIEnv *env, jclass clazz, jmethodID methodID, const jvalue *args))

JNIENVFN(135, jfloat,        CallStaticFloatMethod,         (JNIEnv *env, jclass clazz, jmethodID methodID, ...))
JNIENVFN(136, jfloat,        CallStaticFloatMethodV,        (JNIEnv *env, jclass clazz, jmethodID methodID, va_list args))
JNIENVFN(137, jfloat,        CallStaticFloatMethodA,        (JNIEnv *env, jclass clazz, jmethodID methodID, const jvalue *args))

JNIENVFN(138, jdouble,       CallStaticDoubleMethod,        (JNIEnv *env, jclass clazz, jmethodID methodID, ...))
JNIENVFN(139, jdouble,       CallStaticDoubleMethodV,       (JNIEnv *env, jclass clazz, jmethodID methodID, va_list args))
JNIENVFN(140, jdouble,       CallStaticDoubleMethodA,       (JNIEnv *env, jclass clazz, jmethodID methodID, const jvalue *args))

JNIENVFN(141, void,          CallStaticVoidMethod,          (JNIEnv *env, jclass cls, jmethodID methodID, ...))
JNIENVFN(142, void,          CallStaticVoidMethodV,         (JNIEnv *env, jclass cls, jmethodID methodID, va_list args))
JNIENVFN(143, void,          CallStaticVoidMethodA,         (JNIEnv *env, jclass cls, jmethodID methodID, const jvalue *args))

JNIENVFN(144, jfieldID,      GetStaticFieldID,              (JNIEnv *env, jclass clazz, const char *name, const char *sig))

JNIENVFN(145, jobject,       GetStaticObjectField,          (JNIEnv *env, jclass clazz, jfieldID fieldID))
JNIENVFN(146, jboolean,      GetStaticBooleanField,         (JNIEnv *env, jclass clazz, jfieldID fieldID))
JNIENVFN(147, jbyte,         GetStaticByteField,            (JNIEnv *env, jclass clazz, jfieldID fieldID))
JNIENVFN(148, jchar,         GetStaticCharField,            (JNIEnv *env, jclass clazz, jfieldID fieldID))
JNIENVFN(149, jshort,        GetStaticShortField,           (JNIEnv *env, jclass clazz, jfieldID fieldID))
JNIENVFN(150, jint,          GetStaticIntField,             (JNIEnv *env, jclass clazz, jfieldID fieldID))
JNIENVFN(151, jlong,         GetStaticLongField,            (JNIEnv *env, jclass clazz, jfieldID fieldID))
JNIENVFN(152, jfloat,        GetStaticFloatField,           (JNIEnv *env, jclass clazz, jfieldID fieldID))
JNIENVFN(153, jdouble,       GetStaticDoubleField,          (JNIEnv *env, jclass clazz, jfieldID fieldID))

JNIENVFN(154, void,          SetStaticObjectField,          (JNIEnv *env, jclass clazz, jfieldID fieldID, jobject value))
JNIENVFN(155, void,          SetStaticBooleanField,         (JNIEnv *env, jclass clazz, jfieldID fieldID, jboolean value))
JNIENVFN(156, void,          SetStaticByteField,            (JNIEnv *env, jclass clazz, jfieldID fieldID, jbyte value))
JNIENVFN(157, void,          SetStaticCharField,            (JNIEnv *env, jclass clazz, jfieldID fieldID, jchar value))
JNIENVFN(158, void,          SetStaticShortField,           (JNIEnv *env, jclass clazz, jfieldID fieldID, jshort value))
JNIENVFN(159, void,          SetStaticIntField,             (JNIEnv *env, jclass clazz, jfieldID fieldID, jint value))
JNIENVFN(160, void,          SetStaticLongField,            (JNIEnv *env, jclass clazz, jfieldID fieldID, jlong value))
JNIENVFN(161, void,          SetStaticFloatField,           (JNIEnv *env, jclass clazz, jfieldID fieldID, jfloat value))
JNIENVFN(162, void,          SetStaticDoubleField,          (JNIEnv *env, jclass clazz, jfieldID fieldID, jdouble value))

JNIENVFN(163, jstring,       NewString,                     (JNIEnv *env, const jchar *unicode, jsize len))
JNIENVFN(164, jsize,         GetStringLength,               (JNIEnv *env, jstring str))
JNIENVFN(165, const jchar *, GetStringChars,                (JNIEnv *env, jstring str, jboolean *isCopy))
JNIENVFN(166, void,          ReleaseStringChars,            (JNIEnv *env, jstring str, const jchar *chars))

JNIENVFN(167, jstring,       NewStringUTF,                  (JNIEnv *env, const char *utf))
JNIENVFN(168, jsize,         GetStringUTFLength,            (JNIEnv *env, jstring str))
JNIENVFN(169, const char *,  GetStringUTFChars,             (JNIEnv *env, jstring str, jboolean *isCopy))
JNIENVFN(170, void,          ReleaseStringUTFChars,         (JNIEnv *env, jstring str, const char *chars))

JNIENVFN(171, jsize,         GetArrayLength,                (JNIEnv *env, jarray array))

JNIENVFN(172, jobjectArray,  NewObjectArray,                (JNIEnv *env, jsize len, jclass clazz, jobject init))
JNIENVFN(173, jobject,       GetObjectArrayElement,         (JNIEnv *env, jobjectArray array, jsize index))
JNIENVFN(174, void,          SetObjectArrayElement,         (JNIEnv *env, jobjectArray array, jsize index, jobject val))

JNIENVFN(175, jbooleanArray, NewBooleanArray,               (JNIEnv *env, jsize len))
JNIENVFN(176, jbyteArray,    NewByteArray,                  (JNIEnv *env, jsize len))
JNIENVFN(177, jcharArray,    NewCharArray,                  (JNIEnv *env, jsize len))
JNIENVFN(178, jshortArray,   NewShortArray,                 (JNIEnv *env, jsize len))
JNIENVFN(179, jintArray,     NewIntArray,                   (JNIEnv *env, jsize len))
JNIENVFN(180, jlongArray,    NewLongArray,                  (JNIEnv *env, jsize len))
JNIENVFN(181, jfloatArray,   NewFloatArray,                 (JNIEnv *env, jsize len))
JNIENVFN(182, jdoubleArray,  NewDoubleArray,                (JNIEnv *env, jsize len))

JNIENVFN(183, jboolean *,    GetBooleanArrayElements,       (JNIEnv *env, jbooleanArray array, jboolean *isCopy))
JNIENVFN(184, jbyte *,       GetByteArrayElements,          (JNIEnv *env, jbyteArray array, jboolean *isCopy))
JNIENVFN(185, jchar *,       GetCharArrayElements,          (JNIEnv *env, jcharArray array, jboolean *isCopy))
JNIENVFN(186, jshort *,      GetShortArrayElements,         (JNIEnv *env, jshortArray array, jboolean *isCopy))
JNIENVFN(187, jint *,        GetIntArrayElements,           (JNIEnv *env, jintArray array, jboolean *isCopy))
JNIENVFN(188, jlong *,       GetLongArrayElements,          (JNIEnv *env, jlongArray array, jboolean *isCopy))
JNIENVFN(189, jfloat *,      GetFloatArrayElements,         (JNIEnv *env, jfloatArray array, jboolean *isCopy))
JNIENVFN(190, jdouble *,     GetDoubleArrayElements,        (JNIEnv *env, jdoubleArray array, jboolean *isCopy))

JNIENVFN(191, void,          ReleaseBooleanArrayElements,   (JNIEnv *env, jbooleanArray array, jboolean *elems, jint mode))
JNIENVFN(192, void,          ReleaseByteArrayElements,      (JNIEnv *env, jbyteArray array, jbyte *elems, jint mode))
JNIENVFN(193, void,          ReleaseCharArrayElements,      (JNIEnv *env, jcharArray array, jchar *elems, jint mode))
JNIENVFN(194, void,          ReleaseShortArrayElements,     (JNIEnv *env, jshortArray array, jshort *elems, jint mode))
JNIENVFN(195, void,          ReleaseIntArrayElements,       (JNIEnv *env, jintArray array, jint *elems, jint mode))
JNIENVFN(196, void,          ReleaseLongArrayElements,      (JNIEnv *env, jlongArray array, jlong *elems, jint mode))
JNIENVFN(197, void,          ReleaseFloatArrayElements,     (JNIEnv *env, jfloatArray array, jfloat *elems, jint mode))
JNIENVFN(198, void,          ReleaseDoubleArrayElements,    (JNIEnv *env, jdoubleArray array, jdouble *elems, jint mode))

JNIENVFN(199, void,          GetBooleanArrayRegion,         (JNIEnv *env, jbooleanArray array, jsize start, jsize l, jboolean *buf))
JNIENVFN(200, void,          GetByteArrayRegion,            (JNIEnv *env, jbyteArray array, jsize start, jsize len, jbyte *buf))
JNIENVFN(201, void,          GetCharArrayRegion,            (JNIEnv *env, jcharArray array, jsize start, jsize len, jchar *buf))
JNIENVFN(202, void,          GetShortArrayRegion,           (JNIEnv *env, jshortArray array, jsize start, jsize len, jshort *buf))
JNIENVFN(203, void,          GetIntArrayRegion,             (JNIEnv *env, jintArray array, jsize start, jsize len, jint *buf))
JNIENVFN(204, void,          GetLongArrayRegion,            (JNIEnv *env, jlongArray array, jsize start, jsize len, jlong *buf))
JNIENVFN(205, void,          GetFloatArrayRegion,           (JNIEnv *env, jfloatArray array, jsize start, jsize len, jfloat *buf))
JNIENVFN(206, void,          GetDoubleArrayRegion,          (JNIEnv *env, jdoubleArray array, jsize start, jsize len, jdouble *buf))

JNIENVFN(207, void,          SetBooleanArrayRegion,         (JNIEnv *env, jbooleanArray array, jsize start, jsize l, const jboolean *buf))
JNIENVFN(208, void,          SetByteArrayRegion,            (JNIEnv *env, jbyteArray array, jsize start, jsize len, const jbyte *buf))
JNIENVFN(209, void,          SetCharArrayRegion,            (JNIEnv *env, jcharArray array, jsize start, jsize len, const jchar *buf))
JNIENVFN(210, void,          SetShortArrayRegion,           (JNIEnv *env, jshortArray array, jsize start, jsize len, const jshort *buf))
JNIENVFN(211, void,          SetIntArrayRegion,             (JNIEnv *env, jintArray array, jsize start, jsize len, const jint *buf))
JNIENVFN(212, void,          SetLongArrayRegion,            (JNIEnv *env, jlongArray array, jsize start, jsize len, const jlong *buf))
JNIENVFN(213, void,          SetFloatArrayRegion,           (JNIEnv *env, jfloatArray array, jsize start, jsize len, const jfloat *buf))
JNIENVFN(214, void,          SetDoubleArrayRegion,          (JNIEnv *env, jdoubleArray array, jsize start, jsize len, const jdouble *buf))

JNIENVFN(215, jint,          RegisterNatives,               (JNIEnv *env, jclass clazz, const JNINativeMethod *methods, jint nMethods))
JNIENVFN(216, jint,          UnregisterNatives,             (JNIEnv *env, jclass clazz))

JNIENVFN(217, jint,          MonitorEnter,                  (JNIEnv *env, jobject obj))
JNIENVFN(218, jint,          MonitorExit,                   (JNIEnv *env, jobject obj))

JNIENVFN(219, jint,          GetJavaVM,                     (JNIEnv *env, JavaVM **vm))

JNIENVFN(220, void,          GetStringRegion,               (JNIEnv *env, jstring str, jsize start, jsize len, jchar *buf))
JNIENVFN(221, void,          GetStringUTFRegion,            (JNIEnv *env, jstring str, jsize start, jsize len, char *buf))

JNIENVFN(222, void *,        GetPrimitiveArrayCritical,     (JNIEnv *env, jarray array, jboolean *isCopy))
JNIENVFN(223, void,          ReleasePrimitiveArrayCritical, (JNIEnv *env, jarray array, void *carray, jint mode))

JNIENVFN(224, const jchar *, GetStringCritical,             (JNIEnv *env, jstring string, jboolean *isCopy))
JNIENVFN(225, void,          ReleaseStringCritical,         (JNIEnv *env, jstring string, const jchar *cstring))

JNIENVFN(226, jweak,         NewWeakGlobalRef,              (JNIEnv *env, jobject obj))
JNIENVFN(227, void,          DeleteWeakGlobalRef,           (JNIEnv *env, jweak ref))

JNIENVFN(228, jboolean,      ExceptionCheck,                (JNIEnv *env))

JNIENVFN(229, jobject,       NewDirectByteBuffer,           (JNIEnv *env, void *address, jlong capacity))
JNIENVFN(230, void *,        GetDirectBufferAddress,        (JNIEnv *env, jobject buf))
JNIENVFN(231, jlong,         GetDirectBufferCapacity,       (JNIEnv *env, jobject buf))

JNIENVLAST(232)

#undef JNIENVFN
#undef JNIENVLAST
