/*
 * user32_files.c
 *
 * wrapper functions for syscalls that deal with ipc. 
 * for internal wrapper.
 *
 */
 /*
 *
 * Copyright (C) 2005       Yoav Zach <yoav.zach@intel.com>
 * Copyright (C) 2005       Eric Lin <eric.lin@intel.com>
 * Copyright (C) 2005       Bruce Chen <bruce.chen@intel.com>
 * Copyright (C) 2005       Dror Shenkar <dror.shenkar@intel.com>
 * Copyright (C) 2005       Gordon Jin <gordon.jin@intel.com>
 *
 */
 /*
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of GNU Lesser General Public
 * License as published by the Free Software Foundation
 * version 2.1 of the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have recieved a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * or view it at http://www.gnu.org/licenses/lgpl.html
 *
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*/


#include <ia32x_utils.h>
#include "user32.h"

#include "list.h"
#include "ia32toia64.h"



long HIDDEN 
sys32_pipe (int fd)
{
	long retval, err;
	int  kfd[2];

	/* libc's pipe is not good enough */
	kfd[0] = SYSCALL (pipe, ());
	__asm__ __volatile__ ("mov %0 = r10;;\n" : "=r"(err)); 
	__asm__ __volatile__ ("mov %0 = r9;;\n" : "=r"(kfd[1])); 

	if (err) {
		retval = kfd[0];
	} else {
		retval = (g_safe_memcpy (I2P(fd), kfd, sizeof(kfd)) < 0) ? -EFAULT : 0;
	}

	return retval;
}
	


long HIDDEN 
sys32_pipe2 (__u32 fds, int flags)
{
	long retval;
	int  kfd[2];

	/* libc's pipe is not good enough */
	retval = SYSCALL (pipe2, (kfd, flags));

	if (!IS_SYS_ERROR(retval)) {
		retval = (g_safe_memcpy (I2P(fds), kfd, sizeof(kfd)) < 0) ? -EFAULT : 0;
	}

	return retval;
}
