/*  
 * btlib_ptemu.h
 *  
 * this file contains definitions for btlib_ptemu.h. 
 * 
*/
 /*
 *
 * Copyright (C) 2005       Yoav Zach <yoav.zach@intel.com>
 * Copyright (C) 2005       Eric Lin <eric.lin@intel.com>
 * Copyright (C) 2005       Bruce Chen <bruce.chen@intel.com>
 * Copyright (C) 2005       Dror Shenkar <dror.shenkar@intel.com>
 *
 */
 /*
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of GNU Lesser General Public
 * License as published by the Free Software Foundation
 * version 2.1 of the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have recieved a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * or view it at http://www.gnu.org/licenses/lgpl.html
 *
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*/

#ifndef _BTLIB_PTEMU_H
#define _BTLIB_PTEMU_H

#define IS_PTRACED_NO 0ul 
#define IS_PTRACED_YES_NOT_READY 1ul 
#define IS_PTRACED_YES  2ul

typedef struct _debugee_t {
	struct _debugee_t *next;	/* next elem in the list */
	unsigned long flags;	/* info about debugee */
	unsigned long blst;	/* blst of the debugee */
	BTGENERIC_IA32_CONTEXT orig_bc32;	/* 32 bit context at the point
						 * where debuggee was stopped */
	int bc32_changed;	/* flag indicating whether the bc32 context was changed
				 * since the debuggee was stopped */
	int pid;		/* pid of debugee */
	int stop_signo;		/* the signal that made the debugee stop
				 * assigned at btlib_ptemu_wait. need to
				 * be cleared upon continuing the debugee - 
				 * ptemu_cont, ptemu_syscall, ptemu_singlestep
				 */
} debugee_t;

extern long btlib_ptemu_sig0_selfkill (int state_change_notify);
extern __u64 btlib_set_dbr64 (const BTGENERIC_IA64_CONTEXT * ctx64_p, __u64 requested_regs);
extern void detach_all_debugee (void);
extern debugee_t *find_debugee (int);
debugee_t *add_debugee (int);
void remove_debugee (debugee_t *);
extern long set_debugee_ptrace (debugee_t *debugee, unsigned long ptrace);
extern long get_debugee_ptrace (debugee_t *debugee, unsigned long *ptrace_p);
#endif				// _BTLIB_PTEMU_H
