/* 
 * strings.h
 * prototypes of string functions
 */
 /*
 *
 * This file has been derived from GNU libc. Please see COPYING.LIBC
 * for more information
 *
 */
 /*
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of GNU Lesser General Public
 * License as published by the Free Software Foundation
 * version 2.1 of the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have recieved a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * or view it at http://www.gnu.org/licenses/lgpl.html
 *
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*/

#ifndef _STRINGS_H
#define _STRINGS_H

extern void *bt_memcpy(void *dest, const void *src, unsigned long n);
extern void *bt_memset(void *s, int c, unsigned long n);
extern void *bt_memmove(void *dest, const void *src, unsigned long n);
extern int bt_memcmp(const void *s1, const void *s2, unsigned long n);

extern char *bt_strcat(char *dest, const char *src);
extern char *bt_strncat(char *dest, const char *src, unsigned long len);
extern int bt_strcmp(const char *s1, const char *s2);
extern char *bt_strcpy(char *dest, const char *src);
extern unsigned long bt_strlen(const char *s);
extern unsigned long bt_strnlen (const char * string, unsigned long maxlen);
extern char * bt_strchr (const char * s, int c);
extern int bt_strncmp(const char *s1, const char *s2, unsigned long len);
extern char *bt_strncpy(const char *dest, const char *src, unsigned long n);
extern char * bt_strstr(const char *haystack, const char *needle);

extern int bt_snprintf(char *str, unsigned long max_len, const char *format, ...);
extern long bt_atol(const char *nptr);
extern unsigned long bt_axtoul(const char *p, int * len);


#endif // _STRINGS_H

