/* 
 * loader_tls.h
 * definitions for tls implementation
 */
 /*
 *
 * This file has been derived from GNU libc. Please see COPYING.LIBC
 * for more information
 *
 */
 /*
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of GNU Lesser General Public
 * License as published by the Free Software Foundation
 * version 2.1 of the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have recieved a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * or view it at http://www.gnu.org/licenses/lgpl.html
 *
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*/
#ifndef _LOADER_TLS_H
#define _LOADER_TLS_H


/* size of the thread descriptor allocated by the library */
#define TLS_PRE_TCB_SIZE 0

/* dtv and tcbhead are copied from nptl sources sysdeps/ia64/tls.h */
/* Type of the dtv.  */
typedef union dtv {
	unsigned long counter;
	void *pointer;
} dtv_t;
/* Type of the TCB.  */
typedef struct tcbhead {
	dtv_t *dtv;                   /* Vector of pointers to TLS data.  */
	void * private;
} tcbhead_t;

/* manage tls */
extern void get_tls_static_info (unsigned long *sizep, unsigned long *alignp);
extern long allocate_initial_tls (Elf64_Phdr * tls_phdr);
extern long init_tls (void * r13);
extern void cleanup_tls (void * r13);
extern long cleanup_initial_tls (void * r13);
#ifndef BTLIB_H
register void * __r13 asm ("r13");
#endif
#endif // _LOADER_TLS_H
