/*  
 * syscalls.S
 *  
 * implementation of sys_* functions
 * 
 */
 /*
 *
 * This file has been derived from GNU libc. Please see COPYING.LIBC
 * for more information
 * This file has been derived from GNU libc. Please see COPYING.LIBC
 * for more information
 *
 */
 /*
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of GNU Lesser General Public
 * License as published by the Free Software Foundation
 * version 2.1 of the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have recieved a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * or view it at http://www.gnu.org/licenses/lgpl.html
 *
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*/

/* from asm/unistd.h */
#define __NR_exit                       1025
#define __NR_read                       1026
#define __NR_write                      1027
#define __NR_open                       1028
#define __NR_close                      1029
#define __NR_execve			1033
#define __NR_lseek                      1040
#define __NR_geteuid                    1047
#define __NR_getegid                    1063
#define __NR_fcntl                      1066
#define __NR_getresuid			1073
#define __NR_setresuid			1074
#define __NR_getresgid			1075
#define __NR_setresgid			1076
#define __NR_getgroups			1077
#define __NR_readlink                   1092
#define __NR_gettid                     1105
#define __NR_pread                      1148
#define __NR_mmap                       1151
#define __NR_munmap                     1152
#define __NR_mprotect                   1155
#define __NR_mremap                     1156
#define __NR_getpagesize		1171
#define __NR_stat			1210
#define __NR_fstat			1212

#define __NR_setxattr                   1217
#define __NR_lsetxattr                  1218
#define __NR_fsetxattr                  1219
#define __NR_getxattr                   1220
#define __NR_lgetxattr                  1221
#define __NR_fgetxattr                  1222
#define __NR_listxattr                  1223
#define __NR_llistxattr                 1224
#define __NR_flistxattr                 1225
#define __NR_removexattr                1226
#define __NR_lremovexattr               1227
#define __NR_fremovexattr               1228



#define __NR_exit_group                 1236
#define __IA64_BREAK_SYSCALL            0x100000


#define SYSCALL(name)      		\
.psr abi64                 		;\
.psr lsb                   		;\
.lsb                       		;\
.text                      		;\
.global sys_##name         		;\
.proc sys_##name           		;\
sys_##name:                 		;\
.prologue				;\
.save ar.pfs, r11			;\
mov r11 = ar.pfs			;\
.body					;\
mov r15 = __NR_##name			;\
;;					;\
break __IA64_BREAK_SYSCALL		;\
;;					;\
cmp.eq	p6,p7=r10,r0			;\
;;					;\
(p7)sub	r8=r0, r8			;\
mov ar.pfs = r11			;\
br.ret.sptk.many rp			;\
;;					;\
.endp sys_##name





SYSCALL(open)
SYSCALL(close)
SYSCALL(mmap)
SYSCALL(mremap)
SYSCALL(munmap)
SYSCALL(mprotect)
SYSCALL(pread)
SYSCALL(write)
SYSCALL(lseek)
SYSCALL(getpagesize)
SYSCALL(exit)
SYSCALL(exit_group)
SYSCALL(gettid)
SYSCALL(execve)
SYSCALL(stat)
SYSCALL(fstat)
SYSCALL(fcntl)
SYSCALL(getresuid)
SYSCALL(getresgid)
SYSCALL(setresuid)
SYSCALL(setresgid)
SYSCALL(getgroups)
SYSCALL(read)
SYSCALL(geteuid)
SYSCALL(getegid)
SYSCALL(readlink)
SYSCALL(getxattr)
SYSCALL(setxattr)
