/* 
 * utils.h
 * header file for util functions.
 *
 */
 /*
 *
 * This file has been derived from GNU libc. Please see COPYING.LIBC
 * for more information
 *
 */
 /*
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of GNU Lesser General Public
 * License as published by the Free Software Foundation
 * version 2.1 of the License.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Lesser General Public License for more details.
 *
 * You should have recieved a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * or view it at http://www.gnu.org/licenses/lgpl.html
 *
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*/
#ifndef _UTILS_H
#define _UTILS_H

typedef unsigned long u64;
typedef long s64;
typedef unsigned u32;
typedef int s32;


# define SYSCALL(s,p) sys_##s p

#include <ia32x_utils.h>

/* misc */
#define UNUSED __attribute__((unused))
#define OFFSETOF(field,struct_type) (u64)&(((struct_type*)0)->field)
#define ROUNDDOWN(x,y)       (((x)/(y))*(y))
#define PATH_MAX        4096
#define BITS_PER_BYTE 8
#define MAX_STR_LEN 1024



extern int g_log_file;
#define STDOUT_FILENO 1
#define stdout STDOUT_FILENO
//#define printf(fmt,args...) fprintf (1, fmt, ## args)

#if DEBUG
#	define DBCODE(sw,stmnt) if (sw) stmnt
#else
#	define DBCODE(sw,stmnt)
#endif

extern u64 g_pagesize;
#define getpagesize() g_pagesize

#if 0
int bt_snprintf(char *str, u64 max_len, const char *format, ...);
extern void *bt_memset(void *s, int c, unsigned long n);
extern void *bt_memcpy(void *dest, const void *src, unsigned long n);
extern int bt_strcmp(const char *s1, const char *s2);
extern char *bt_strncpy(const char *dest, const char *src, unsigned long n);
extern unsigned long bt_strnlen (const char * string, unsigned long maxlen);
extern int bt_strncmp(const char *s1, const char *s2, unsigned long len);
#endif
extern void * zmalloc (u64 size);
extern void zfree (void * addr);


#endif // _UTILS_H
